#include "Std.h"
#include "Malical.h"


FUNCTION *Function[STACK_SIZE];
int       FunctionSize;
Object	  ReturnObject;

void func_push (const char *name,int pos)
{
	Function[FunctionSize] = (FUNCTION*)malloc(sizeof(FUNCTION));
	strcpy(Function[FunctionSize]->name,name);
	Function[FunctionSize]->pos = pos;
	FunctionSize++;
}
int find_func (const char *name)
{
	int i;
	for(i=0;i<FunctionSize;++i)
		if(str_eq(Function[i]->name,name)) return Function[i]->pos;
	return -1;
}

VarStack GlobalVar={0,0};
VarStack *LocalVar[STACK_SIZE];
int LocalTop;

void var_copy (Variable *d,Variable *s)
{
	strcpy(d->name,s->name);
	obj_copy(&d->obj,&s->obj);
}

void var_create (Variable *v,const char *name,Object *obj)
{
	strcpy(v->name,name);
	obj_copy(&v->obj,obj);
}

void var_stk_push (VarStack * vs,Variable *v)
{
	int i = vs->size;
	vs->vars[i] = (Variable*)malloc(sizeof(Variable));
	vs->vars[i]->name[0] = '\0';
	obj_ini(& vs->vars[i]->obj);
	if( v != 0 )var_copy(vs->vars[i],v);
	++vs->size;
}

void var_stk_clear (VarStack * vs)
{
	while(vs->size>0)
	{
		vs->size--;
		if (vs->vars[vs->size]->obj.tag == VT_ARR)
		{
			Array *a;
			a = (Array*)(vs->vars[vs->size]->obj.value.ref);
			if(a)
			{
				array_destory(a);
				free(a);
			}
		}
		obj_clear(&vs->vars[vs->size]->obj);
		free(vs->vars[vs->size]);
	}
}

void new_local_var_stack ()
{
	LocalTop++;
	LocalVar[LocalTop]=(VarStack*)malloc(sizeof(VarStack));
	LocalVar[LocalTop]->size = 0;
}
void delete_local_var_stack ()
{
	if(LocalTop<0) return;
	var_stk_clear(LocalVar[LocalTop]);
	free(LocalVar[LocalTop]);
	LocalTop--;
}

Variable* find_var (char *name)
{
	int i;
	VarStack * local = 0;
	if (LocalTop>=0)
	{
		local = LocalVar[LocalTop];
		for(i=0;i<local->size;++i)
			if(str_eq(local->vars[i]->name,name)) return local->vars[i];
	}
	for(i=0;i<GlobalVar.size;++i)
		if(str_eq(GlobalVar.vars[i]->name,name)) return GlobalVar.vars[i];
	return 0;
}