#include "Std.h"
#include "Malical.h"

void mcl_exit(ObjectStack *arg_stk,Object *objr);


char *prog;
extern int ac_break;

char token[TOKEN_BUFFER_SIZE];
char line[TOKEN_BUFFER_SIZE];

enum RSTATE // state of running
{
	NOTHING,
	END,
	ELSE,
	RETURN
}state = NOTHING;

void CallFun (const char *name,ObjectStack *arg_stk)
{
	int p = find_func(name);
	int pl = 0,i;
	if (p<0) MalicalError("Function cannot be found");
	p = GetLine(prog,p);
	obj_clear(&ReturnObject);
	new_local_var_stack();
	for(i=0;! LineEmpty(pl);++i)
	{
		pl = Match(line,"[",0,pl);
		pl = Match(line,0,TT_SYM,pl);
		var_stk_push(LocalVar[LocalTop],0);
		strcpy (LocalVar[LocalTop]->vars[i]->name,token);
		pl = Match(line,"]",0,pl);
	}
	if (arg_stk != 0)
	{
		if (LocalVar[LocalTop]->size != arg_stk->size)
			MalicalError("Wrong number of func parameter");
		else
		{
			for (i=0;i<arg_stk->size;++i)
			{
				obj_copy(&LocalVar[LocalTop]->vars[i]->obj,arg_stk->stk[i]);
			}
		}
	}
	RunFunction(p,1,B_NO);
	delete_local_var_stack();
	state = NOTHING;
}

int RunIfBlock (int p,int todo,int _todo)
{
	while (prog[p])
	{
		p = RunFunction(p,todo && _todo,B_IF);
		if (state == END)
		{
			state = NOTHING;
			return p;
		}
		else if (state == ELSE) 
		{
			todo=!todo;
		}
		else if (state==RETURN)
		{
			return p;
		}
	}
	return p;
}
int RunWhileBlock (int b,char *expr,int _todo)
{
	int p = b;
	int todo;
	Object obj;

	if( _todo ){
		obj_ini(&obj);
		EvalExpr(expr,&obj);
		if (obj.tag != VT_NUM)
			MalicalError("while statement condition need boolean value");
		todo = obj.value.d;
	}
	else
		todo = 0;

	while (prog[p])
	{
		p = RunFunction(p,todo && _todo,B_OT);
		if (state == END)
		{
			state = NOTHING;
			if(todo && _todo==0)return p;
			if( _todo ){
				EvalExpr(expr,&obj);
				if (obj.tag != VT_NUM)
					MalicalError("while statement condition need boolean value");
				todo = obj.value.d;
			}
			else
				todo = 0;
			if (!todo)
			{
				return p;
			}
			p = b;
		}
		else if (state==RETURN)
		{
			return p;
		}
	}
	return p;
}
int RunFunction (int p,int todo,int is_block)
{
	int type,pl;
	state = NOTHING;

	while (prog[p])
	{
		if (state==RETURN)
		{
			state = NOTHING;
			return p;
		}
		p = GetLine(prog,p);
		pl = GetToken (line,0,&type);
		if (str_eq(token,"var"))
		{
			if( todo ){
				int i;
				for(i=LocalVar[LocalTop]->size;! LineEmpty(pl);++i)
				{
					pl = Match(line,"[",0,pl);
					pl = Match(line,0,TT_SYM,pl);
					var_stk_push(LocalVar[LocalTop],0);
					strcpy (LocalVar[LocalTop]->vars[i]->name,token);
					pl = Match(line,"]",0,pl);
				}
			}
			if (is_block!=0)return p;
		}
		else if (str_eq(token,"if"))
		{
			int _todo;
			if( todo ){
				Object obj;
				char buf[TOKEN_BUFFER_SIZE];
				obj_ini(&obj);
				strcpy(buf,line+pl);
				EvalExpr(buf,&obj);
				if (obj.tag != VT_NUM)
					MalicalError("if statement condition need boolean value");
				_todo = obj.value.d;
				obj_clear(&obj);
			}
			else
				_todo = 0;
			p = RunIfBlock(p, _todo,todo);
			if (is_block!=0)return p;
		}
		else if (str_eq(token,"while"))
		{
			char buf[TOKEN_BUFFER_SIZE];
			strcpy(buf,line+pl);
			p = RunWhileBlock (p,buf,todo);
			if (is_block!=0)return p;
		}
		else if (str_eq(token,"end"))
		{
			if (is_block==B_NO)MalicalTokenError();
			if (! LineEmpty(pl))MalicalTokenError();
			state = END;
			return p;
		}
		else if (str_eq(token,"return"))
		{
			if (todo)
			{
				if (!LineEmpty(pl))
				{
					char buf[TOKEN_BUFFER_SIZE];
					strcpy(buf,line+pl);
					EvalExpr(buf,&ReturnObject);
				}
				state = RETURN;
				return p;
			}
		}
		else if (str_eq(token,"else"))
		{
			if (is_block!=B_IF) MalicalTokenError();
			if (! LineEmpty(pl))MalicalTokenError();
			state = ELSE;
			return p;
		}
		else if  (str_eq(token,"::"))
		{
			pl = Match(line,"end",0,pl);
			return p;
		}
		else
		{
			char buf[TOKEN_BUFFER_SIZE];
			if (!LineEmpty(0))
			{
				strcpy(buf,line);
				if (todo) EvalExpr(buf,0);
			}
			if (is_block!=0)return p;
		}
	}
	return p;
}
int MalicalPrescan ()
{
	int p = 0,type;

	while (prog[p>0?p-1:0]) // all prog
	{
		int pl = 0;
		p = GetLine(prog,p);
		pl = GetToken (line,pl,&type);
		if(str_eq(token,"var"))
		{
			while(! LineEmpty(pl))
			{
				pl = Match(line,"[",0,pl);
				pl = Match(line,0,TT_SYM,pl);
				var_stk_push(&GlobalVar,0);
				strcpy(&GlobalVar.vars[GlobalVar.size-1]->name,token);
				pl = Match(line,"]",0,pl);
			}
		}
		else if (str_eq(token,"::"))
		{
			int complete = 0;
			pl = Match(line,0,TT_SYM,pl);
			func_push(token,p-strlen(line)+pl-1);
			do
			{
				p = GetLine(prog,p);
				pl = GetToken(line,0,&type);
				if (str_eq(token,"::"))
				{
					pl = GetToken(line,pl,&type);
					if (str_eq(token,"end"))
					{
						complete = 1;break;
					}
					else MalicalError("cannot find the end of fun");
				}
			}while(prog[p]);
			if (!complete) MalicalError("cannot find the end of fun");
		}// ::
		else if(str_eq(token,"set"))
		{
			while(! LineEmpty(pl))
			{
				pl = Match(line,0,TT_SYM,pl);
				if( strcmp( token, "ac_break" ) == 0 )
					ac_break = 1;
				else
					MalicalError("Illegal set");
			}
		}
	}
}

int RunFile (char* file_name)
{
    FONTCHARACTER ffile_name[20];
    int fsiz,fh;

    CharToFont(file_name,ffile_name);

    fh = Bfile_OpenFile(ffile_name,_OPENMODE_READ_SHARE);
    if( fh < 0 )
		MalicalError("File not found");
    fsiz = Bfile_GetFileSize(fh);

    prog = (char*)malloc(fsiz+1);
    if( prog == 0 )
		MalicalError ("No enough mem");

    Bfile_ReadFile(fh,prog,fsiz,0);
    Bfile_CloseFile(fh);

    prog[fsiz]=0;
    MalicalPrescan(prog);
    CallFun("main",0);

	mcl_exit( 0, 0 );
}