#include "std.h"
#include "Malical.h"
#include <stdarg.h>

void fullprint (char *s)
{
	char c[]={0,0};
	int x=1,y=1;

	Bdisp_AllClr_DDVRAM();
	while(*s)
	{
		c[0] = *s;
		if(*s=='\n')
		{
			x = 1;
			y++;
		}	
		else
		{
			locate(x,y);
			Print(c);
			++x;
			if(x>21)
			{
				++y;
				x=1;
			}
		}
		++s;
	}
}
int fullprintf (char *cpFormat, ...)
{
	char cpBuffer[STRING_BUFFER_SIZE];
	va_list pArgList;

	va_start(pArgList, cpFormat);
	vsprintf(cpBuffer, cpFormat, pArgList);
	va_end(pArgList);
	fullprint(cpBuffer);
	return 0;
}
int Printf(char *cpFormat, ...)
{
	char cpBuffer[STRING_BUFFER_SIZE];
	va_list pArgList;

	va_start(pArgList, cpFormat);
	vsprintf(cpBuffer, cpFormat, pArgList);
	va_end(pArgList);
	Print(cpBuffer);
	return 0;
}
int PrintfRev(char *cpFormat, ...)
{
	char cpBuffer[STRING_BUFFER_SIZE];
	va_list pArgList;

	va_start(pArgList, cpFormat);
	vsprintf(cpBuffer, cpFormat, pArgList);
	va_end(pArgList);
	PrintRev(cpBuffer);
	return 0;
}
int PrintfXY(int x,int y,int sel,char *cpFormat, ...)
{
	char cpBuffer[STRING_BUFFER_SIZE];
	va_list pArgList;

	va_start(pArgList, cpFormat);
	vsprintf(cpBuffer, cpFormat, pArgList);
	va_end(pArgList);
	PrintXY(x,y,cpBuffer,sel);
	return 0;
}
int PrintfMini(int x,int y,int sel,char *cpFormat, ...)
{
	char cpBuffer[STRING_BUFFER_SIZE];
	va_list pArgList;

	va_start(pArgList, cpFormat);
	vsprintf(cpBuffer, cpFormat, pArgList);
	va_end(pArgList);
	PrintMini(x,y,cpBuffer,sel);
	return 0;
}
int PrintNum( double num )
{
	char cpBuffer[STRING_BUFFER_SIZE];
	int i;

    i = sprintf( cpBuffer, "%lf", num); 
	while( cpBuffer[--i] == '0' )
		;
	if( cpBuffer[i] != '.' ){
		i++;
	}
	cpBuffer[i] = '\0';
    Print( cpBuffer );
	return 0;
}
int PrintNumXY( int x, int y, int sel, double num )
{
	char cpBuffer[STRING_BUFFER_SIZE];
	int i;

    i = sprintf( cpBuffer, "%lf", num); 
	while( cpBuffer[--i] == '0' )
		;
	if( cpBuffer[i] != '.' ){
		i++;
	}
	cpBuffer[i] = '\0';
    PrintXY( x, y, cpBuffer, sel );
	return 0;
}
int PrintNumMini(int x,int y,int sel,double num)
{
	char cpBuffer[STRING_BUFFER_SIZE];
	int i;

    i = sprintf( cpBuffer, "%lf", num); 
	while( cpBuffer[--i] == '0' )
		;
	if( cpBuffer[i] != '.' ){
		i++;
	}
	cpBuffer[i] = '\0';
	PrintMini(x,y,cpBuffer,sel);
	return 0;
}
void DrawCircle( int x0, int y0, int r )
{
	int x, y, s;

	for( x = x0 - r; x <= x0 + r; x++ ){
		for( y = y0 - r; y <= y0 + r; y++ ){
			s = (x - x0)*(x - x0) + (y - y0)*(y - y0);
			if( abs(s - r*r) <  r )
				Bdisp_SetPoint_VRAM( x, y, 1); 
		}
	}
}

void DrawPicture( int x,int y,int width,int height,int kind,int mod,unsigned char * pGraph)
{ 
    DISPGRAPH dg; 
    dg.x = x; 
    dg.y = y; 
    dg.GraphData.width = width; 
    dg.GraphData.height = height; 
    dg.GraphData.pBitmap = pGraph; 
    dg.WriteModify = mod; 
    dg.WriteKind = kind; 
    Bdisp_WriteGraph_DDVRAM(&dg); 
}

char GetPressChar(int key)
{
	char ch = 0;
	switch (key)
	{
		case KEY_CHAR_POW:ch = '^';break;
		case KEY_CHAR_LPAR:ch = '(';break;
		case KEY_CHAR_RPAR:ch = ')';break;
		case KEY_CHAR_LBRCKT:ch = '[';break;
		case KEY_CHAR_RBRCKT:ch = ']';break;
		case KEY_CHAR_PLUS :ch = '+';break;
		case KEY_CHAR_MINUS:ch = '-';break;
		case KEY_CHAR_MULT :ch = '*';break;
		case KEY_CHAR_DIV  :ch = '/';break;
		case KEY_CHAR_SPACE:ch = ' ';break;
		default:
			if (	key>=KEY_CHAR_0 && key<=KEY_CHAR_9 || key == KEY_CHAR_DP)
				ch = key;
			else if (key>=KEY_CHAR_A && key<=KEY_CHAR_Z)
				ch = key + 32;
			else if(key==KEY_CHAR_MINUS || key== KEY_CHAR_PMINUS)
				ch = '-';
			break;
	}
	return ch;
}
int InputString(int x, int y, char *c,int len)
{
	unsigned int key;
	char ch;
	int i = strlen(c);
	c[i] = ch = 0;
	locate(x,y);Print("_");
	locate(x,y);Print(c);
	while (1)
	{
		GetKey (&key);
		if (ch=GetPressChar(key))
		{
			if (i<len)
			{
				int j,f = 0;
				for (j=0;j<=i;++j)
					if (c[j]=='.')
					{
						f = 1;
						break;
					}
				if(ch=='.')
				{
					if (!f) c[i++] = ch;
				}
				else
				{
					c[i++] = ch;
				}
			}
		}
		else
		{
			if (key==KEY_CTRL_AC)	
			{
				int j;
				locate(x,y);
				for( j = 0; j <= strlen(c); j++ )
					Print( " " );
				i = 0;
			}
			else if (key==KEY_CTRL_DEL)
			{
				locate( x+strlen(c), y );
				Print( " " );
				if (i>0) c[i--] = 0;
			}
			else if(key==KEY_CTRL_EXE)
			{
				locate(x+i,y);Print(" ");
				return key;
			}
		}
		c[i] = ch = 0;
		locate(x,y);Print(c);
		locate(x+i,y);Print("_");
	}
}